
package main

import "fmt"

// Global variable
var status string = "initial global status"

func main() {
   // Local variable
   msg := "initial local message"

   defer func() {
      if r := recover(); r != nil {
         fmt.Println("Recovered from panic:", r)
         fmt.Println("Captured global status:", status) // Accesses global variable
         fmt.Println("Captured local message:", msg)    // Accesses local variable
      }
   }()

   // Modify both global and local variables
   status = "updated global status before panic"
   msg = "updated local message before panic"
    
   panic("Something went wrong!")
}
