
package main

import (
   "fmt"
   "time"
   "sync"
)

var ccc int
var mu sync.Mutex

const (
    WW = 150   // sleep wait loops in main
    NN = 100   // sleep seconds in each process to sim workload
    PP = 5000000  // total number of processes to spawn
)

func burner (k int) {
   //fmt.Printf("Hello world, starts goroutine %d \n", k)
   mu.Lock()
   ccc = ccc + 1
   mu.Unlock()
   time.Sleep(NN*time.Second)
   mu.Lock()
   ccc = ccc - 1
   mu.Unlock()
}

func spawnem(n int) {
   for (n>0) {
      go burner(n)
      n = n-1
   }
   fmt.Println("all processes spawned")
}

func main() {
   ccc = 0
   go spawnem(PP) // not gonna wait until all spawning is done
                  // we want to see the counter go up
   k := 1
   for (k < WW) {
      fmt.Printf("count: %d \n", ccc)
      time.Sleep(2 * time.Second)
      k = k+1
   }
   fmt.Println("\nend main function")
}

