
package main

import (
  "fmt"
  "time"
)

func worker(id int, jobs <-chan int, results chan<- int) {
   for job := range jobs {
      fmt.Printf("Worker %d processing job %d\n", id, job)
      time.Sleep(1*time.Second)
      results <- job * job // Example of work done
                           // better if job was some data structure and we get it
                           // to produce an int to square
                           // or if it were a pattern with an "execute" operation
   }  
}

func main() {
   jobs := make(chan int, 100)
   results := make(chan int, 100)

   // start 3 workers
   for w := 1; w <= 3; w++ { go worker(w, jobs, results) }

   // parcel out jobs
   jmax := 40
   for j := 1; j <= jmax; j++ { jobs <- j }
   close(jobs)

   // get results
   for r := 1; r <= jmax; r++ { fmt.Println(<-results) }
}

