package main

import "fmt"

// Define the Person struct
type Person struct {
   Name string    // exported
   Age  int       // exported
}

// Method with a value receiver
func (p Person) IncAgeByVal(y int) { 
   fmt.Println("  >> entering IncAgeByVal, Age is ", p.Age)
   p.Age += y 
   fmt.Println("  >> about to leave IncAgeByVal, Age is ", p.Age)
}

// Method with a pointer receiver
func (p *Person) IncAgeByPtr(y int) { 
   fmt.Println("  >> entering IncAgeByPtr, Age is ", p.Age)
   p.Age += y 
   fmt.Println("  >> about to leave IncAgeByPtr, Age is ", p.Age)
}

func main() {
   person := Person{Name: "Alice", Age: 30}
   fmt.Println("Beginning Main: ", person.Age) // Output: Age starts 30

   person.IncAgeByVal(5)
   fmt.Println("Main after calling IncAgeByValue:", person.Age) // Output: Age remains 30

   person.IncAgeByPtr(5)
   fmt.Println("Main after calling IncAgeByPtr:", person.Age)   // Output: Age is now 35
}
