
package main

import "fmt"

func main() {
   for i := 0; i < 3; i++ {
      defer fmt.Println(i) // Defer happens only at the end of main()
   }
}

// defer statements are held until the function they are in is 
// about to return (or exit)
// they are stacked (pushed onto a stack) as the are encountered
// and when the func ends they are popped off the stack
// and so executed in the reverse order of how they are 
// encountered
//
// i.e. most recent defer is done first... oldest defer done last