//package main
//import (
///   "fmt"
//   "time"
//)

//func main() {
//   quit := make(chan struct{}) // Create the channel
//   go func() {
//      fmt.Println("go routine starting, and waiting for msg on quit chan")
//      <-quit // Wait for the signal to quit
//      fmt.Println("go routine received msg on quit chan")
//      fmt.Println("go routine quitting")
//   }()

//   // now main code...
//   fmt.Println("main... working") 
//   time.Sleep(2*time.Second)
//   fmt.Println("main... working") 
//   time.Sleep(2*time.Second)
//   fmt.Println("main... working") 
//   time.Sleep(2*time.Second)

//   fmt.Println("main... sending quit chan msg") 
//   //close(quit)
//   quit <- struct{}{}   // send an empty struct to the chan
//   time.Sleep(2*time.Second)
//   fmt.Println("main... quitting") 
//}




package main

import (
   "fmt"
   "time"
)

func main() {
   // Create the quit channel
   quit := make(chan struct{})

   // Start a goroutine that does some work and listens for a quit signal
   go func() {
      for {
         select {
            case <-quit:
               // Quit signal received, exit the goroutine
               fmt.Println("Received quit signal. Exiting goroutine...")
               return
            default:
               // Continue doing work (printing every second)
               fmt.Println("Goroutine is working...")
               time.Sleep(1 * time.Second)
         }
      }
   }()

   // Let the goroutine print for a few seconds
   time.Sleep(6 * time.Second)

   // Send a signal to stop the goroutine
   quit <- struct{}{} // Sending an empty struct{} value as a signal

   // Wait for the goroutine to finish (just for demonstration purposes)
   time.Sleep(2 * time.Second)
}
